diff -bruN freeswan-1.9.orig/pluto/ipsec_doi.c freeswan-1.9/pluto/ipsec_doi.c
--- freeswan-1.9.orig/pluto/ipsec_doi.c	Sun Jan 28 16:03:04 2001
+++ freeswan-1.9/pluto/ipsec_doi.c	Mon Jun 11 16:44:14 2001
@@ -1995,210 +2726,1117 @@
     /* Advance state */
     st->st_state = STATE_MAIN_R2;
 
+    DBG(DBG_PARSING,
+    DBG_log("finished main_inI2_outR2");
+    );
+
     return STF_REPLY;
 }
 
-/* STATE_MAIN_I2:
- * SMF_PSK_AUTH: HDR, KE, Nr --> HDR*, IDi1, HASH_I
- * SMF_DS_AUTH: HDR, KE, Nr --> HDR*, IDi1, [ CERT, ] SIG_I
- *
- * The following are not yet implemented.
- * SMF_PKE_AUTH: HDR, KE, <IDr1_b>PubKey_i, <Nr_b>PubKey_i
- *	    --> HDR*, HASH_I
- * SMF_RPKE_AUTH: HDR, <Nr_b>PubKey_i, <KE_b>Ke_r, <IDr1_b>Ke_r
- *	    --> HDR*, HASH_I
+#ifdef OPENSSL
+/* Handle HDR;KE;<IDii_b>PubKey_r;<Ni_b>PubKey_r from Initiator.
+ * Send a HDR;KE;<IDir_b>PubKey_i;<Nr_b>PubKey_i back.
  */
 stf_status
-main_inR2_outI3(struct msg_digest *md)
+main_inI2_outR2_pk(struct msg_digest *md)
 {
     struct state *const st = md->st;
-    pb_stream *const keyex_pbs = &md->chain[ISAKMP_NEXT_KE]->pbs;
-    int auth_payload = st->st_oakley.auth == OAKLEY_PRESHARED_KEY
-	? ISAKMP_NEXT_HASH : ISAKMP_NEXT_SIG;
+    pb_stream *keyex_pbs = &md->chain[ISAKMP_NEXT_KE]->pbs;
+
+    DBG(DBG_PARSING,
+    DBG_log("in main_inI2_outR2_pk");
+    );
 
     /* KE in */
-    RETURN_STF_FAILURE(accept_KE(&st->st_gr, "Gr", st->st_oakley.group, keyex_pbs));
+    RETURN_STF_FAILURE(accept_KE(&st->st_gi, "Gi", 
+      st->st_oakley.group, keyex_pbs));
 
-    /* Nr in */
-    RETURN_STF_FAILURE(accept_nonce(md, &st->st_nr, "Nr"));
+    if (!decode_peer_id(md, FALSE))
+    return STF_FAIL + INVALID_ID_INFORMATION;
 
-    /* done parsing; initialize crypto  */
+    /* Ni_b<PubKey_r> in */
+    RETURN_STF_FAILURE(accept_nonce(md, &st->st_ni, "<Ni_b>PubKey_r"));
 
-    compute_dh_shared(st, st->st_gr, st->st_oakley.group);
-#ifdef DODGE_DH_MISSING_ZERO_BUG
-    if (st->st_shared.ptr[0] == 0)
-	return STF_REPLACE_DOOMED_EXCHANGE;
-#endif
-    if (!generate_skeyids_iv(st))
-	return STF_FAIL + AUTHENTICATION_FAILED;
+    /** build output packet HDR;KE;<IDir_b>_PubKey_i;<Nr_b>PubKey_i*********/
 
-    /*************** build output packet HDR*;IDii;HASH/SIG_I ***************/
-    /* ??? NOTE: this is almost the same as main_inI3_outR3's code */
+    /* HDR out done */
 
-    /* HDR* out done */
+    /* KE out */
+    if (!build_and_ship_KE(st, &st->st_gr, st->st_oakley.group, 
+    &md->rbody, ISAKMP_NEXT_ID))
+	return STF_INTERNAL_ERROR;
 
-    /* IDii out */
     {
-	struct isakmp_ipsec_id id_hd;
-	chunk_t id_b;
-	pb_stream id_pbs;
+      /* <IDir_b>PubKey_i out */
+      chunk_t ch;
 
-	build_id_payload(&id_hd, &id_b, &st->st_connection->this);
-	id_hd.isaiid_np = auth_payload;
-	if (!out_struct(&id_hd, &isakmp_ipsec_identification_desc, &md->rbody, &id_pbs)
-	|| !out_chunk(id_b, &id_pbs, "my identity"))
-	    return STF_INTERNAL_ERROR;
-	close_output_pbs(&id_pbs);
+      if (st->st_connection->this.id.kind == ID_DER_ASN1_DN) {
+        ch.len = st->st_connection->this.id.der_asn1_dn.len + 4;
+        ch.ptr = alloc_bytes(ch.len, "plaintext der_asn1_dn identity");
+        ch.ptr[0] = (u_int8_t)st->st_connection->this.id.kind;
+        memset(&(ch.ptr[1]), 0, 1);
+        memset(&(ch.ptr[2]), 0, 2);
+        memcpy(&(ch.ptr[4]), 
+          st->st_connection->this.id.der_asn1_dn.ptr, 
+          st->st_connection->this.id.der_asn1_dn.len);     
+      } else {
+        ch.len = sizeof(st->st_connection->this.id.ip_addr) + 4;
+        ch.ptr = alloc_bytes(ch.len, "plaintext identity");
+        ch.ptr[0] = (u_int8_t)st->st_connection->this.id.kind;
+        memset(&(ch.ptr[1]), 0, 1);
+        memset(&(ch.ptr[2]), 0, 2);
+        memcpy(&(ch.ptr[4]), &(st->st_connection->this.id.ip_addr),
+          sizeof(st->st_connection->this.id.ip_addr));
     }
 
-    /* HASH_I or SIG_I out */
-    {
-	u_char hash_val[MAX_DIGEST_LEN];
-	size_t hash_len = main_mode_hash(st, hash_val, TRUE, TRUE);
 
-	if (auth_payload == ISAKMP_NEXT_HASH)
-	{
-	    /* HASH_I out */
-	    if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_hash_desc, &md->rbody
-	    , hash_val, hash_len, "HASH_I"))
+      /* PK encrypt this */
+      if (! pubkey_encrypt_chunk( &ch, st )) {
 		return STF_INTERNAL_ERROR;
 	}
-	else
-	{
-	    /* SIG_I out */
-	    u_char sig_val[RSA_MAX_OCTETS];
-	    size_t sig_len = RSA_sign_hash(st->st_connection
-		, sig_val, hash_val, hash_len);
-
-	    if (sig_len == 0)
-	    {
-		loglog(RC_LOG_SERIOUS, "unable to locate my private key for RSA Signature");
-		return STF_FAIL + AUTHENTICATION_FAILED;
+      if (!out_generic_chunk(ISAKMP_NEXT_NONCE, &isakmp_generic_desc, &md->rbody, ch, "my identity (ciphertext)"))
+	return STF_INTERNAL_ERROR;
+      memset(ch.ptr, 0, ch.len);
+      freeanychunk(ch);
 	    }
 
-	    if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_signature_desc
-	    , &md->rbody, sig_val, sig_len, "SIG_I"))
+    /* Nr out */
+    if (!build_and_ship_nonce_pk(st, &st->st_nr, &md->rbody, ISAKMP_NEXT_NONE, "<Nr_b>PubKey_i"))
 		return STF_INTERNAL_ERROR;
-	}
-    }
 
-    /* encrypt message, except for fixed part of header */
+    /* finish message */
+    close_message(&md->rbody);
 
-    /* st_new_iv was computed by generate_skeyids_iv */
-    if (!encrypt_message(&md->rbody, st))
-	return STF_INTERNAL_ERROR;	/* ??? we may be partly committed */
+    /* next message will be encrypted, but not this one.
+     * We could defer this calculation.
+     */
+#ifndef DODGE_DH_MISSING_ZERO_BUG
+    compute_dh_shared(st, st->st_gi, st->st_oakley.group);
+#endif
+    if (!generate_skeyids_iv(st))
+	return STF_FAIL + AUTHENTICATION_FAILED;
+    update_iv(st);
 
     /* Advance state */
-    st->st_state = STATE_MAIN_I3;
+    st->st_state = STATE_MAIN_R2;
+
+    DBG(DBG_PARSING,
+    DBG_log("finished main_inI2_outR2_pk");
+    );
 
     return STF_REPLY;
 }
+#endif /* OPENSSL */
 
-/* STATE_MAIN_R2:
- * PSK_AUTH: HDR*, IDi1, HASH_I --> HDR*, IDr1, HASH_R
- * DS_AUTH: HDR*, IDi1, [ CERT, ] SIG_I --> HDR*, IDr1, [ CERT, ] SIG_R
- * PKE_AUTH, RPKE_AUTH: HDR*, HASH_I --> HDR*, HASH_R
+#ifdef OPENSSL
+/* Handle HDR;<Ni_b>Pubkey_r;<KE_b>Ke_i;<IDi1_b>Ke_i[;<cert>Ke_r] from Initiator
+ * Send a HDR;<Nr_b>Pubkey_i;<KE_b>Ke_r;<IDr1_b>Ke_r[;<cert>Ke_r] back.
  */
 stf_status
-main_inI3_outR3(struct msg_digest *md)
+main_inI2_outR2_rpk(struct msg_digest *md)
 {
     struct state *const st = md->st;
-    int auth_payload = st->st_oakley.auth == OAKLEY_PRESHARED_KEY
-	? ISAKMP_NEXT_HASH : ISAKMP_NEXT_SIG;
+    pb_stream *keyex_pbs = &md->chain[ISAKMP_NEXT_KE]->pbs;
 
-    /* input code similar to main_inR3 -- should be factored */
+    DBG(DBG_PARSING,
+    DBG_log("in main_inI2_outR2_rpk");
+    );
+
+    /* Ni_b<PubKey_r> in */
+    RETURN_STF_FAILURE(accept_nonce(md, &st->st_ni, "<Ni_b>PubKey_r"));
+
+    /* KE<Ke_r> in */
+    RETURN_STF_FAILURE(accept_KE(&st->st_gi, "Gi", 
+      st->st_oakley.group, keyex_pbs));
 
-    /* IDii in */
     if (!decode_peer_id(md, FALSE))
 	return STF_FAIL + INVALID_ID_INFORMATION;
 
-    /* HASH_I or SIG_I in */
-    RETURN_STF_FAILURE(check_main_authenticator(md, TRUE));
+    /**************** build output packet ****************/
 
-    /*************** build output packet HDR*;IDir;HASH/SIG_R ***************/
-    /* ??? NOTE: this is almost the same as main_inR2_outI3's code */
+    /* HDR out done */
 
-    /* IDir out */
-    {
-	struct isakmp_ipsec_id id_hd;
-	chunk_t id_b;
-	pb_stream r_id_pbs;
+    /* Nr out */
+    if (!build_and_ship_nonce_pk(st, &st->st_nr, &md->rbody, 
+      ISAKMP_NEXT_KE, "<Nr_b>PubKey_i")) 
+      return STF_INTERNAL_ERROR;
 
-	build_id_payload(&id_hd, &id_b, &st->st_connection->this);
-	id_hd.isaiid_np = auth_payload;
-	if (!out_struct(&id_hd, &isakmp_ipsec_identification_desc, &md->rbody, &r_id_pbs)
-	|| !out_chunk(id_b, &r_id_pbs, "my identity"))
+    if (derive_symmetric_key(st, st->st_nr,
+			     st->st_rcookie, COOKIE_SIZE,
+			     &st->st_ks_r,
+			     &st->st_ne_r) < 0) {
+      log("error while deriving symmetric key in revised mode");
 	    return STF_INTERNAL_ERROR;
-	close_output_pbs(&r_id_pbs);
     }
+    memset(st->st_ne_r_iv, 0, MAX_DIGEST_LEN);
 
-    /* HASH_R or SIG_R out */
-    {
-	u_char hash_val[MAX_DIGEST_LEN];
-	size_t hash_len = main_mode_hash(st, hash_val, FALSE, TRUE);
+    DBG(DBG_PARSING,
+    DBG_dump_chunk("Generated Ke_r:", st->st_ne_r);
+    );
 
-	if (auth_payload == ISAKMP_NEXT_HASH)
-	{
-	    /* HASH_R out */
-	    if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_hash_desc, &md->rbody
-	    , hash_val, hash_len, "HASH_R"))
+    /* KE out */
+    if (!build_and_ship_KE_rpk(st, FALSE, &st->st_gr, st->st_oakley.group
+			       , &md->rbody, ISAKMP_NEXT_ID))
 		return STF_INTERNAL_ERROR;
-	}
-	else
-	{
-	    /* SIG_R out */
-	    u_char sig_val[RSA_MAX_OCTETS];
-	    size_t sig_len = RSA_sign_hash(st->st_connection
-		, sig_val, hash_val, hash_len);
 
-	    if (sig_len == 0)
+    /* <IDr1_b>Ke_r[<cert>Ke_r] out */
 	    {
-		loglog(RC_LOG_SERIOUS, "unable to locate my private key for RSA Signature");
-		return STF_FAIL + AUTHENTICATION_FAILED;
+      chunk_t ch, out;
+
+      if (st->st_connection->this.id.kind == ID_DER_ASN1_DN) {
+        ch.len = st->st_connection->this.id.der_asn1_dn.len + 4;
+        ch.ptr = alloc_bytes(ch.len, "encrypted der_asn1_dn identity");
+        ch.ptr[0] = (u_int8_t)st->st_connection->this.id.kind;
+        memset(&(ch.ptr[1]), 0, 1);
+        memset(&(ch.ptr[2]), 0, 2);
+        memcpy(&(ch.ptr[4]), 
+          st->st_connection->this.id.der_asn1_dn.ptr, 
+          st->st_connection->this.id.der_asn1_dn.len);     
+      } else {
+        ch.len = sizeof(st->st_connection->this.id.ip_addr) + 4;
+        ch.ptr = alloc_bytes(ch.len, "encrypted identity");
+        ch.ptr[0] = (u_int8_t)st->st_connection->this.id.kind;
+        memset(&(ch.ptr[1]), 0, 1);
+        memset(&(ch.ptr[2]), 0, 2);
+        memcpy(&(ch.ptr[4]), &(st->st_connection->this.id.ip_addr),
+          sizeof(st->st_connection->this.id.ip_addr));
 	    }
 
-	    if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_signature_desc
-	    , &md->rbody, sig_val, sig_len, "SIG_R"))
+      if (!encrypt_payload(st, &st->st_ks_r, st->st_ne_r_iv,
+        ch, &out))
 		return STF_INTERNAL_ERROR;
+      freeanychunk(ch);
+
+      /* Are we going to send CERT? */
+      if ((st->st_connection->cert_options & CERT_OPTION_SEND) == 0) {
+        if (!out_generic_chunk(ISAKMP_NEXT_NONE, &isakmp_generic_desc,
+          &md->rbody, out, "my identity (ciphertext)")) 
+        {
+	  freeanychunk(out);
+	  return STF_INTERNAL_ERROR;
+        }
+      } else {
+        if (!out_generic_chunk(ISAKMP_NEXT_CERT, &isakmp_generic_desc,
+          &md->rbody, out, "my identity (ciphertext)")) 
+        {
+	  freeanychunk(out);
+	  return STF_INTERNAL_ERROR;
+        }
+      }
+      freeanychunk(out);
+    }
+
+        /* Well, if we do send CERT, let's start on it from here */
+        if ((st->st_connection->cert_options & CERT_OPTION_SEND) != 0) {
+
+          chunk_t crt, cx, out;
+          unsigned long ulen;
+          /* Send the signing certificate */
+
+          ulen = i2d_X509(st->st_connection->cert, NULL);
+          ulen++;
+          if ((cx.ptr = alloc_bytes(ulen, "ASN.1 cert")) == NULL)
+          { 
+            return STF_INTERNAL_ERROR; 
+          }
+          (cx.ptr)[0] = (u_char)(CERT_TYPE_X509_SIG);
+          cx.len = ulen;
+          crt.ptr = &(cx.ptr[1]);
+          crt.len = i2d_X509(st->st_connection->cert, &(crt.ptr));
+
+          DBG(DBG_CRYPT,
+          DBG_log("plaintext Certificate length: %d", cx.len);
+          DBG_dump_chunk("plaintext Certificate", cx);
+          );
+
+          /* encrypt the certificate to send */
+          if (!encrypt_payload(st, &st->st_ks_r, st->st_ne_r_iv,
+            cx, &out))
+          return STF_INTERNAL_ERROR;
+
+          DBG(DBG_CRYPT,
+          DBG_log("cyphertext Certificate length: %d", out.len);
+          DBG_dump_chunk("cyphertext Certificate", out);
+          );
+
+          if (!out_generic_chunk(ISAKMP_NEXT_NONE, 
+            &isakmp_ipsec_certificate_desc,
+            &md->rbody, out, "my certificate (ciphertext)")) 
+          {
+            freeanychunk(out);
+            return STF_INTERNAL_ERROR;
+          }
+        }
+        /* end of sending out cert */
+    
+    /* finish message */
+    close_message(&md->rbody);
+
+    /* next message will be encrypted, but not this one.
+     * We could defer this calculation.
+     */
+#ifndef DODGE_DH_MISSING_ZERO_BUG
+    compute_dh_shared(st, st->st_gi, st->st_oakley.group);
+#endif
+    if (!generate_skeyids_iv(st))
+	return STF_FAIL + AUTHENTICATION_FAILED;
+    update_iv(st);
+
+    /* Advance state */
+    st->st_state = STATE_MAIN_R2;
+
+    DBG(DBG_PARSING,
+    DBG_log("finished main_inI2_outR2_rpk");
+    );
+
+    return STF_REPLY;
+}
+#endif /* OPENSSL */
+
+
+/* STATE_MAIN_I2:
+ * SMF_PSK_AUTH: HDR, KE, Nr --> HDR*, IDi1, HASH_I
+ * SMF_DS_AUTH: HDR, KE, Nr --> HDR*, IDi1, [ CERT, ] SIG_I
+ *
+ * The following are not yet implemented.
+ * SMF_PKE_AUTH: HDR, KE, <IDr1_b>PubKey_i, <Nr_b>PubKey_i
+ *	    --> HDR*, HASH_I
+ * SMF_RPKE_AUTH: HDR, <Nr_b>PubKey_i, <KE_b>Ke_r, <IDr1_b>Ke_r
+ *	    --> HDR*, HASH_I
+ */
+stf_status
+main_inR2_outI3(struct msg_digest *md)
+{
+    struct state *const st = md->st;
+#ifdef OPENSSL
+    struct connection *c = st->st_connection;
+#endif
+
+    pb_stream *const keyex_pbs = &md->chain[ISAKMP_NEXT_KE]->pbs;
+
+    int auth_payload = st->st_oakley.auth == OAKLEY_PRESHARED_KEY
+	? ISAKMP_NEXT_HASH : ISAKMP_NEXT_SIG;
+
+    DBG(DBG_PARSING,
+    DBG_log("in main_inR2_outI3");
+    );
+
+    /* KE in */
+    RETURN_STF_FAILURE(accept_KE(&st->st_gr, "Gr", 
+		st->st_oakley.group, keyex_pbs));
+
+    /* Nr in */
+    RETURN_STF_FAILURE(accept_nonce(md, &st->st_nr, "Nr"));
+
+    /* done parsing; initialize crypto  */
+
+    compute_dh_shared(st, st->st_gr, st->st_oakley.group);
+#ifdef DODGE_DH_MISSING_ZERO_BUG
+    if (st->st_shared.ptr[0] == 0)
+       return STF_REPLACE_DOOMED_EXCHANGE;
+#endif
+    if (!generate_skeyids_iv(st))
+	return STF_FAIL + AUTHENTICATION_FAILED;
+
+    /*************** build output packet HDR*;IDii;HASH/SIG_I ***************/
+    /* ??? NOTE: this is almost the same as main_inI3_outR3's code */
+
+    /* HDR* out done */
+
+    /* IDii out */
+    {
+	struct isakmp_ipsec_id id_hd;
+	chunk_t id_b;
+	pb_stream id_pbs;
+
+	build_id_payload(&id_hd, &id_b, &st->st_connection->this);
+#ifdef OPENSSL
+if (use_openssl(st->st_connection)) 
+{
+  switch(st->st_oakley.auth) {
+  case OAKLEY_RSA_SIG:
+  case OAKLEY_DSS_SIG:
+    if ((c->cert_options & CERT_OPTION_SEND) == 0)
+      id_hd.isaiid_np = ISAKMP_NEXT_SIG;
+    else
+      id_hd.isaiid_np = ISAKMP_NEXT_CERT;
+    break;
+  case OAKLEY_RSA_ENC:
+  case OAKLEY_RSA_ENC_REV:
+    log("RSA method not supported yet");
+    return STF_INTERNAL_ERROR;
+    break;
+  default:
+    id_hd.isaiid_np = ISAKMP_NEXT_HASH;
+    break;
+  }
+}
+else
+{
+#endif /* OPENSSL */
+	id_hd.isaiid_np = auth_payload;
+#ifdef OPENSSL
+}
+#endif /* OPENSSL */
+
+	if (!out_struct(&id_hd, &isakmp_ipsec_identification_desc, &md->rbody, &id_pbs)
+		|| !out_chunk(id_b, &id_pbs, "my identity")) 
+		return STF_INTERNAL_ERROR;
+	close_output_pbs(&id_pbs);
+    } /* IDii out done */
+
+#ifdef OPENSSL
+if (use_openssl(st->st_connection)) 
+{
+    if (((c->cert_options & CERT_OPTION_SEND) != 0) &&
+  ((st->st_oakley.auth == OAKLEY_RSA_SIG) ||
+   (st->st_oakley.auth == OAKLEY_DSS_SIG))) {
+      u_char *crt, *cx;
+      unsigned long ulen;
+      /* Send the signing certificate */
+
+      ulen = i2d_X509(c->cert, NULL);
+      ulen++;
+      if ((cx = alloc_bytes(ulen, "ASN.1 cert")) == NULL)
+  { return STF_INTERNAL_ERROR; }
+      cx[0] = (u_char)(CERT_TYPE_X509_SIG);
+      crt = &(cx[1]);
+      i2d_X509(c->cert, &crt);
+      if (!out_generic_raw(ISAKMP_NEXT_SIG, &isakmp_ipsec_certificate_desc
+             , &md->rbody, cx, ulen, "CERT_I"))
+  return STF_INTERNAL_ERROR;
+      pfree(cx);
+    }
+
+  /* HASH_I out, OPENSSL */
+  {
+	u_char hash_val[MAX_DIGEST_LEN];
+	size_t hash_len = main_mode_hash(st, hash_val, TRUE, TRUE);
+    u_char *buf;
+    u_int elen;
+    bool ok;
+
+  /* Output the signature/hash as defined by the selected Oakley transform */
+
+  switch (st->st_oakley.auth) {
+  case OAKLEY_RSA_SIG: /* output signed HASH_I */
+    if ((buf = alloc_bytes(EVP_PKEY_size(c->key) + 32 /* bit of slack */,
+               "RSA signature")) == NULL)
+        return STF_INTERNAL_ERROR;
+    elen = RSA_private_encrypt(hash_len, hash_val, buf,
+                   ((EVP_PKEY *)(c->key))->pkey.rsa,
+                   RSA_PKCS1_PADDING);
+    if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_signature_desc, &md->rbody
+                 , buf, elen, "SIG_I"))
+      return STF_INTERNAL_ERROR;
+    pfree(buf);
+   
+	DBG(DBG_PARSING,
+	    DBG_log("Selected auth mechanism is %s",
+        	enum_show(&oakley_auth_names, st->st_oakley.auth));
+	)
+    break;
+
+  case OAKLEY_DSS_SIG:
+    /* We don't have to check whether the hash is a SHA1 */
+    /* one, since the ciphersuite offering DSA is only */
+    /* configured with SHA1. Don't change this configuration */
+    if (c->cert_options & CERT_OPTION_DSS_SHA)
+      main_mode_sha1(st, hash_val, &hash_len, TRUE, TRUE);
+
+    buf = alloc_bytes(EVP_PKEY_size(c->key) + 32 /* bit of slack */,
+              "DSA signature");
+    if (buf) {
+      ok = (c->cert_options & CERT_OPTION_DSS_ALT)
+        ? DSA_sign_raw(hash_val, hash_len,
+               buf, &elen, ((EVP_PKEY *)(c->key))->pkey.dsa)
+        : DSA_sign(EVP_PKEY_DSA, hash_val, hash_len,
+           buf, &elen, ((EVP_PKEY *)(c->key))->pkey.dsa);
+      if (!ok) {
+        /* DSA signing failed */
+        log_err();
+        return STF_INTERNAL_ERROR;
+      }
+      if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_signature_desc,
+               &md->rbody, buf, elen, "SIG_I"))
+        return STF_INTERNAL_ERROR;
+      pfree(buf);
+    } else
+      return STF_INTERNAL_ERROR;
+   
+	DBG(DBG_PARSING | DBG_CONTROL, 
+	DBG_log("Selected auth mechanism is %s",
+	  enum_show(&oakley_auth_names, st->st_oakley.auth));
+	);
+    break;
+    /* If we get to any of these, something has gone WAY wrong */
+  case OAKLEY_RSA_ENC:
+    return STF_INTERNAL_ERROR;
+  case OAKLEY_ELGAMAL_ENC:
+    return STF_INTERNAL_ERROR;
+  case OAKLEY_RSA_ENC_REV:
+    return STF_INTERNAL_ERROR;
+  case OAKLEY_ELGAMAL_ENC_REV:
+    return STF_INTERNAL_ERROR;
+  default:
+	} /* switch done */
+  } /* HASH_I out, openssl done. */
+}
+else
+{
+#endif /* OPENSSL */
+  /* HASH_I or SIG_I out, !OPENSSL */
+  {
+	u_char hash_val[MAX_DIGEST_LEN];
+	size_t hash_len = main_mode_hash(st, hash_val, TRUE, TRUE);
+
+	if (auth_payload == ISAKMP_NEXT_HASH)
+	{
+	    /* HASH_I out */
+	    if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_hash_desc, &md->rbody
+	    , hash_val, hash_len, "HASH_I"))
+		return STF_INTERNAL_ERROR;
+	}
+	else
+	{
+	    /* SIG_I out */
+	    u_char sig_val[RSA_MAX_OCTETS];
+	    size_t sig_len = RSA_sign_hash(st->st_connection, 
+			sig_val, hash_val, hash_len);
+
+	    if (sig_len == 0)
+	    {
+		loglog(RC_LOG_SERIOUS, "unable to locate my private key for RSA Signature");
+		return STF_FAIL + AUTHENTICATION_FAILED;
+	    }
+
+	    if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_signature_desc
+	    , &md->rbody, sig_val, sig_len, "SIG_I"))
+		return STF_INTERNAL_ERROR;
+	}
+  }
+#ifdef OPENSSL
+}
+#endif /* OPENSSL */
+
+    /* encrypt message, except for fixed part of header */
+
+    /* st_new_iv was computed by generate_skeyids_iv */
+    if (!encrypt_message(&md->rbody, st))
+	return STF_INTERNAL_ERROR;	/* ??? we may be partly committed */
+
+    /* Advance state */
+    st->st_state = STATE_MAIN_I3;
+
+    DBG(DBG_PARSING,
+    DBG_log("finished main_inR2_outI3");
+    );
+
+    return STF_REPLY;
+}
+
+#ifdef OPENSSL
+/*
+ * Handle HDR;KE;<IDir_b>PubKey_i;<Nr_b>PubKey_i from responder.
+ * Send a HDR*;HASH_I back.
+ */
+stf_status main_inR2_outI3_pk(struct msg_digest *md)
+{
+    struct state *const st = md->st;
+    pb_stream *const keyex_pbs = &md->chain[ISAKMP_NEXT_KE]->pbs;
+
+    DBG(DBG_PARSING,
+    DBG_log("in main_inR2_outI3_pk");
+    );
+
+    /* KE in */
+    RETURN_STF_FAILURE(accept_KE(&st->st_gr, "Gr", 
+	st->st_oakley.group, keyex_pbs));
+
+    /* IDir in */
+    if (!decode_peer_id(md, TRUE))
+    return STF_FAIL + INVALID_ID_INFORMATION;
+
+    /* Nr in */
+    RETURN_STF_FAILURE(accept_nonce(md, &st->st_nr, "<Nr_b>PubKey_i"));
+
+    /* done parsing; initialize crypto  */
+
+    compute_dh_shared(st, st->st_gr, st->st_oakley.group);
+#ifdef DODGE_DH_MISSING_ZERO_BUG
+    if (st->st_shared.ptr[0] == 0)
+       return STF_REPLACE_DOOMED_EXCHANGE;
+#endif
+    if (!generate_skeyids_iv(st))
+    return STF_FAIL + AUTHENTICATION_FAILED;
+
+    /**************** build output packet HDR*;HASH_I ****************/
+
+    /* HDR* out done */
+
+    /* HASH_I out */
+    {
+  u_char hash_val[MAX_DIGEST_LEN];
+  size_t hash_len = main_mode_hash(st, hash_val, TRUE, TRUE);
+
+  if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_hash_desc, &md->rbody
+  , hash_val, hash_len, "HASH_I"))
+      return STF_INTERNAL_ERROR;
+    }
+
+    /* encrypt message, except for fixed part of header */
+
+    /* st_new_iv was computed by generate_skeyids_iv */
+    if (!encrypt_message(&md->rbody, st))
+    return STF_INTERNAL_ERROR;  /* ??? we may be partly committed */
+
+    /* Advance state */
+    st->st_state = STATE_MAIN_I3;
+
+    DBG(DBG_PARSING,
+    DBG_log("finished main_inR2_outI3_pk");
+    );
+
+    return STF_REPLY;
+}
+#endif /* OPENSSL */
+
+#ifdef OPENSSL
+/* Handle HDR;KE;<Nr_b>PubKey_i;<KE_b>Ke_r;<IDr1_b>Ke_r from responder.
+ * Send a HDR*;HASH_I back.
+ */
+stf_status
+main_inR2_outI3_rpk(struct msg_digest *md)
+{
+    struct state *const st = md->st;
+    pb_stream *const keyex_pbs = &md->chain[ISAKMP_NEXT_KE]->pbs;
+
+    DBG(DBG_PARSING,
+    DBG_log("in main_inR2_outI3_rpk");
+    );
+
+    /* Nr in */
+    RETURN_STF_FAILURE(accept_nonce(md, &st->st_nr, "<Nr_b>PubKey_i"));
+
+    /* KE in */
+    RETURN_STF_FAILURE(accept_KE(&st->st_gr, "Gr", 
+      st->st_oakley.group, keyex_pbs));
+
+    /* IDir in */
+    if (!decode_peer_id(md, TRUE))
+      return STF_FAIL + INVALID_ID_INFORMATION;
+
+    /* done parsing; initialize crypto  */
+
+    compute_dh_shared(st, st->st_gr, st->st_oakley.group);
+#ifdef DODGE_DH_MISSING_ZERO_BUG
+    if (st->st_shared.ptr[0] == 0)
+	return STF_REPLACE_DOOMED_EXCHANGE;
+#endif
+    if (!generate_skeyids_iv(st))
+  return STF_FAIL + AUTHENTICATION_FAILED;
+
+    /**************** build output packet HDR*;HASH_I ****************/
+
+    /* HDR* out done */
+
+    /* HASH_I out */
+    {
+      u_char hash_val[MAX_DIGEST_LEN];
+
+      size_t hash_len = main_mode_hash(st, hash_val, TRUE, TRUE);
+
+      if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_hash_desc, &md->rbody, 
+        hash_val, hash_len, "HASH_I"))
+      return STF_INTERNAL_ERROR;
+    }
+
+    /* encrypt message, except for fixed part of header */
+
+    /* st_new_iv was computed by generate_skeyids_iv */
+    if (!encrypt_message(&md->rbody, st))
+    return STF_INTERNAL_ERROR;  /* ??? we may be partly committed */
+
+    /* Advance state */
+    st->st_state = STATE_MAIN_I3;
+
+    DBG(DBG_PARSING,
+    DBG_log("fnished main_inR2_outI3_rpk");
+    );
+
+    return STF_REPLY;
+}
+#endif /* OPENSSL */
+
+
+#ifdef OPENSSL
+/* STATE_MAIN_R2:
+ * Which type of DS are we currently handling?
+ * Classic? OPENSSL?
+ */
+stf_status
+main_inI3_outR3_whichds(struct msg_digest *md)
+{ 
+	if (! use_openssl(md->st->st_connection)) {
+		return main_inI3_outR3(md);
+	} else {
+		return main_inI3_outR3_ds(md);
+	}
+}
+#endif /* OPENSSL */
+
+/* STATE_MAIN_R2:
+ * PSK_AUTH: HDR*, IDi1, HASH_I --> HDR*, IDr1, HASH_R
+ * DS_AUTH: HDR*, IDi1, [ CERT, ] SIG_I --> HDR*, IDr1, [ CERT, ] SIG_R
+ * PKE_AUTH, RPKE_AUTH: HDR*, HASH_I --> HDR*, HASH_R
+ */
+stf_status
+main_inI3_outR3(struct msg_digest *md)
+{ 
+    struct state *const st = md->st;
+
+    int auth_payload = st->st_oakley.auth == OAKLEY_PRESHARED_KEY
+	? ISAKMP_NEXT_HASH : ISAKMP_NEXT_SIG;
+
+    DBG(DBG_PARSING,
+    DBG_log("in main_inI3_outR3");
+    );
+
+    /* input code similar to main_inR3 -- should be factored */
+
+    /* IDii in */
+    if (!decode_peer_id(md, FALSE))
+	return STF_FAIL + INVALID_ID_INFORMATION;
+
+    /* HASH_I or SIG_I in */
+    RETURN_STF_FAILURE(check_main_authenticator(md, TRUE));
+
+    /*************** build output packet HDR*;IDir;HASH/SIG_R ***************/
+    /* ??? NOTE: this is almost the same as main_inR2_outI3's code */
+
+    /* IDir out */
+    {
+	struct isakmp_ipsec_id id_hd;
+	chunk_t id_b;
+	pb_stream r_id_pbs;
+
+	build_id_payload(&id_hd, &id_b, &st->st_connection->this);
+	id_hd.isaiid_np = auth_payload;
+	if (!out_struct(&id_hd, &isakmp_ipsec_identification_desc, &md->rbody, &r_id_pbs)
+	|| !out_chunk(id_b, &r_id_pbs, "my identity"))
+	    return STF_INTERNAL_ERROR;
+	close_output_pbs(&r_id_pbs);
+    }
+
+    /* HASH_R or SIG_R out */
+    {
+	u_char hash_val[MAX_DIGEST_LEN];
+	size_t hash_len = main_mode_hash(st, hash_val, FALSE, TRUE);
+
+	if (auth_payload == ISAKMP_NEXT_HASH)
+	{
+	    /* HASH_R out */
+	    if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_hash_desc, &md->rbody
+	    , hash_val, hash_len, "HASH_R"))
+		return STF_INTERNAL_ERROR;
+	}
+	else
+	{
+	    /* SIG_R out */
+	    u_char sig_val[RSA_MAX_OCTETS];
+	    size_t sig_len = RSA_sign_hash(st->st_connection
+		, sig_val, hash_val, hash_len);
+
+	    if (sig_len == 0)
+	    {
+		loglog(RC_LOG_SERIOUS, "unable to locate my private key for RSA Signature");
+		return STF_FAIL + AUTHENTICATION_FAILED;
+	    }
+
+	    if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_signature_desc
+	    , &md->rbody, sig_val, sig_len, "SIG_R"))
+		return STF_INTERNAL_ERROR;
+	}
+    }
+
+    /* encrypt message, sans fixed part of header */
+
+    if (!encrypt_message(&md->rbody, st))
+	return STF_INTERNAL_ERROR;	/* ??? we may be partly committed */
+
+    /* Last block of Phase 1 (R3), kept for Phase 2 IV generation */
+    DBG_cond_dump(DBG_CRYPT, "last encrypted block of Phase 1:"
+	, st->st_new_iv, st->st_new_iv_len);
+
+    /* Advance state */
+    st->st_state = STATE_MAIN_R3;
+    ISAKMP_SA_established(st->st_connection, st->st_serialno);
+
+    /* ??? If st->st_connectionc->gw_info != NULL,
+     * we should keep the public key -- it tested out.
+     */
+
+    return STF_REPLY;
+}
+
+/* STATE_MAIN_I3:
+ * Handle HDR*;IDir;HASH/SIG_R from responder.
+ */
+stf_status
+main_inR3(struct msg_digest *md)
+{
+    struct state *const st = md->st;
+    struct connection *c = st->st_connection;
+
+    DBG(DBG_PARSING,
+    DBG_log("in main_inR3");
+    );
+
+    /* input code similar to main_inI3_outR3 -- should be factored */
+
+    /* IDir in */
+    if (!decode_peer_id(md, TRUE))
+	return STF_FAIL + INVALID_ID_INFORMATION;
+
+    /* HASH_R or SIG_R in */
+    RETURN_STF_FAILURE(check_main_authenticator(md, FALSE));
+
+    /**************** done input ****************/
+
+    /* Advance state */
+    st->st_state = STATE_MAIN_I4;
+    ISAKMP_SA_established(c, st->st_serialno);
+
+    /* ??? If c->gw_info != NULL,
+     * we should keep the public key -- it tested out.
+     */
+
+    update_iv(st);	/* finalize our Phase 1 IV */
+
+    DBG(DBG_PARSING,
+    DBG_log("finished main_inR3");
+    );
+
+    return STF_UNPEND_QUICK;
+}
+
+#ifdef OPENSSL
+/* Handle HDR*;IDir;[CERT];SIG_R from responder.
+ */
+stf_status
+main_inR3_ds(struct msg_digest *md)
+{
+    struct state *const st = md->st;
+    struct connection *c = st->st_connection;
+    u_char hash_val[MAX_DIGEST_LEN], *buf;
+    pb_stream *sig_pbs;
+    unsigned int dlen;
+    struct payload_digest *id_pld;
+    size_t hash_len = main_mode_hash(st, hash_val, FALSE, FALSE);
+    // size_t hash_len;
+    // main_mode_hash(st, hash_val, &hash_len, FALSE, FALSE);
+
+    /* input code similar to main_inI3_outR3 -- should be factored */
+
+    DBG(DBG_PARSING,
+    DBG_log("in main_inR3_ds");
+    );
+
+    /* IDir in */
+    if (!decode_peer_id(md, TRUE))
+      return STF_FAIL + INVALID_ID_INFORMATION;
+
+    switch (st->st_oakley.auth) {
+    case OAKLEY_RSA_SIG: /* check SIG_I */
+      {
+      RSA *rsa;
+      STACK_OF(X509) *peerlist;
+      X509 *recv_cert, *cert;
+      pb_stream *cert_pbs;
+      int i, success;
+
+      recv_cert = NULL;
+      /* First check to see if we have a certificate sent to us */
+      if ((md->chain[ISAKMP_NEXT_CERT] != NULL) &&
+          ((cert_pbs = &md->chain[ISAKMP_NEXT_CERT]->pbs) != NULL)) {
+        u_char *crt;
+        unsigned long len;
+
+        switch(cert_pbs->cur[0]) {
+        case CERT_TYPE_X509_SIG:
+          crt = &(cert_pbs->cur[1]);
+          len = pbs_left(cert_pbs)-1;
+          recv_cert = d2i_X509(NULL, &crt, len);
+          break;
+        default:
+              DBG(DBG_PARSING,
+                      DBG_log("Unhandled certificate encoding: %s",
+                      enum_show(&cert_names, cert_pbs->cur[0]));
+              );
+          break;
+        }
+      }
+
+      if (recv_cert) {
+        char buf[200];
+
+        X509_NAME_oneline(X509_get_subject_name(recv_cert)
+                          , buf, sizeof(buf));
+              DBG(DBG_PARSING,
+                      DBG_log("Sent certificate \"%s\"", buf);
+              );
+      }
+
+      id_pld = md->chain[ISAKMP_NEXT_ID];
+      if ((peerlist =
+           peer_cert_list((STACK_OF(XMAP) *)c->lu,
+                          EVP_PKEY_RSA, recv_cert, id_pld,
+                          (c->cert_options & CERT_OPTION_STRICT) ? TRUE : FALSE)) == NULL) {
+        log("Verification certificate(s) unavailable to check signature in Main R3");
+        return STF_FAIL + INVALID_SIGNATURE;
+      }
+
+      if (sk_X509_num(peerlist) == 0) {
+        log("Unable to get any certificate for peer in Main R3");
+        return STF_FAIL + INVALID_SIGNATURE;
+      }
+
+      if ((md->chain[ISAKMP_NEXT_SIG] == NULL) ||
+              ((sig_pbs = &md->chain[ISAKMP_NEXT_SIG]->pbs) == NULL)) {
+        log("Signature not present in Main R3");
+        return STF_FAIL + INVALID_SIGNATURE;
+      }
+      DBG(DBG_PARSING,
+              DBG_dump("Computed hash", hash_val, hash_len);
+      );
+      /* Iterate through all certificates in the peer list until */
+      /* we have one which verifies the signature, or we have no */
+      /* more certificates to verify with */
+      for(i=0, success=0, buf = NULL; ((success == 0) && (i < sk_X509_num(peerlist))); i++) {
+        rsa = X509_get_pubkey(sk_X509_value(peerlist, i))->pkey.rsa;
+        if ((buf = alloc_bytes(EVP_PKEY_size(X509_get_pubkey(sk_X509_value(peerlist, i))),
+                               "RSA decrypt sig")) != NULL) {
+          dlen = RSA_public_decrypt(pbs_left(sig_pbs), sig_pbs->cur, buf, rsa
+                                    , RSA_PKCS1_PADDING);
+              DBG(DBG_PARSING,
+                      DBG_dump("Decrypted hash", buf, (dlen > hash_len)
+                              ? hash_len : dlen);
+              );
+          if ((dlen == hash_len) && (memcmp(buf, hash_val, hash_len) == 0)) {
+                      DBG(DBG_PARSING,
+                              DBG_log("SIG_R matches computed hash");
+                      )
+            success = 1;
+            cert = X509_dup(sk_X509_value(peerlist, i));
+          } else {
+                      DBG(DBG_PARSING,
+                              DBG_log("SIG_R does not match computed hash");
+                      );
+          }
+          pfree(buf);
+          buf = NULL;
+        }
+      }
+      if (buf) pfree(buf);
+
+      if (!success) {
+        log_err();
+        DBG_cond_dump(DBG_CRYPT,
+                      "received SIG_R does not match computed value in Main R3:"
+                      , sig_pbs->cur, pbs_left(sig_pbs));
+        sk_X509_pop_free(peerlist, X509_free);
+        return STF_FAIL + INVALID_SIGNATURE;
+      } else {
+        /* We know that certificate 'cert' was used to */
+        /* sign the accurate hash which accompanied the method */
+        /* Now we have to verify that it is a valid certificate */
+        /* to be signing anything */
+              DBG(DBG_PARSING,
+                      DBG_log("Verifying certificate along path %s", c->path);
+              );
+              if (verify_certificate( cert, c->lu, c->path,
+                      (c->cert_options & CERT_OPTION_STRICT) ? TRUE : FALSE ))
+              {
+                      DBG(DBG_PARSING,
+                              DBG_log("Signing certificate is valid");
+                      );
+              } else {
+                      sk_X509_pop_free(peerlist, X509_free);
+                      return STF_FAIL + INVALID_CERTIFICATE;
+              }
+      }
+      sk_X509_pop_free(peerlist, X509_free);
+      }
+      break;
+    case OAKLEY_DSS_SIG:
+      {
+      DSA *dsa;
+      STACK_OF(X509) *peerlist;
+      X509 *recv_cert, *cert;
+      pb_stream *cert_pbs;
+      int i, success;
+
+      if (c->cert_options & CERT_OPTION_DSS_SHA)
+        main_mode_sha1(st, hash_val, &hash_len, FALSE, FALSE);
+      recv_cert = NULL;
+      /* First check to see if we have a certificate sent to us */
+      if ((md->chain[ISAKMP_NEXT_CERT] != NULL) &&
+          ((cert_pbs = &md->chain[ISAKMP_NEXT_CERT]->pbs) != NULL)) {
+        u_char *crt;
+        unsigned long len;
+
+        switch(cert_pbs->cur[0]) {
+        case CERT_TYPE_X509_SIG:
+          crt = &(cert_pbs->cur[1]);
+          len = pbs_left(cert_pbs)-1;
+          recv_cert = d2i_X509(NULL, &crt, len);
+          break;
+        default:
+              DBG(DBG_PARSING,
+                  DBG_log("Unhandled certificate encoding: %s",
+                          enum_show(&cert_names, cert_pbs->cur[0]));
+              );
+          break;
+        }
+      }
+
+      if (recv_cert) {
+        char buf[200];
+
+        X509_NAME_oneline(X509_get_subject_name(recv_cert)
+                          , buf, sizeof(buf));
+              DBG(DBG_PARSING,
+                      DBG_log("Sent certificate \"%s\"", buf);
+              );
+      }
+
+      /* We know this field is legitimate, because the */
+      /* decode_peer_id has been called before */
+      id_pld = md->chain[ISAKMP_NEXT_ID];
+
+      if ((peerlist =
+           peer_cert_list((STACK_OF(XMAP) *)c->lu,
+                          EVP_PKEY_DSA, recv_cert,
+                          id_pld,
+                          (c->cert_options & CERT_OPTION_STRICT) ? TRUE : FALSE )) == NULL) {
+        log("Verification certificate(s) unavailable to check signature in Main R3");
+        return STF_FAIL + INVALID_SIGNATURE;
+      }
+
+      if (sk_X509_num(peerlist) == 0) {
+        log("Unable to get any certificate for peer in Main R3");
+        return STF_FAIL + INVALID_SIGNATURE;
+      }
+
+      if ((md->chain[ISAKMP_NEXT_SIG] == NULL) ||
+          ((sig_pbs = &md->chain[ISAKMP_NEXT_SIG]->pbs) == NULL)) {
+        log("Signature not present in Main R3");
+        return STF_FAIL + INVALID_SIGNATURE;
+      }
+      DBG(DBG_PARSING,
+              DBG_dump("Computed hash", hash_val, hash_len);
+      );
+      /* Iterate through all certificates in the peer list until */
+      /* we have one which verifies the signature, or we have no */
+      /* more certificates to verify with */
+      for(i=0, success=0, buf=NULL; ((success == 0) && (i < sk_X509_num(peerlist))); i++) {
+        dsa = X509_get_pubkey(sk_X509_value(peerlist, i))->pkey.dsa;
+        if ((buf = alloc_bytes(SHA1_DIGEST_SIZE, "DSA decrypt sig")) != NULL) {
+          success = (c->cert_options & CERT_OPTION_DSS_ALT)
+            ? DSA_verify_raw(hash_val, hash_len,
+                             sig_pbs->cur, pbs_left(sig_pbs),
+                             dsa)
+            : DSA_verify(EVP_PKEY_DSA,
+                         hash_val, hash_len,
+                         sig_pbs->cur, pbs_left(sig_pbs),
+                         dsa);
+          if (success == 1) {
+                      DBG(DBG_PARSING,
+                              DBG_log("SIG_I matches computed hash");
+                      );
+            cert = X509_dup(sk_X509_value(peerlist, i));;
+          } else if (success == 0) {
+                      DBG(DBG_PARSING,
+                              DBG_log("SIG_I does not match computed hash");
+                      );
+          } else {
+                      DBG(DBG_PARSING,
+                    DBG_log("Verification error");
+                      );
+            log_err();
+          }
+          pfree(buf);
+          buf = NULL;
+        }
+      }
+      if (buf) pfree(buf);
+      if (!success) {
+        log_err();
+        DBG_cond_dump(DBG_CRYPT, "received SIG_I does not match computed value in Main I3:"
+                      , sig_pbs->cur, pbs_left(sig_pbs));
+        sk_X509_pop_free(peerlist, X509_free);
+        return STF_FAIL + INVALID_SIGNATURE;
+      } else {
+        /* We know that certificate 'cert' was used to */
+        /* sign the accurate hash which accompanied the method */
+        /* Now we have to verify that it is a valid certificate */
+        /* to be signing anything */
+              DBG(DBG_PARSING,
+                      DBG_log("Verifying certificate along path %s", c->path);
+              );
+        if (verify_certificate( cert, c->lu, c->path, (c->cert_options & CERT_OPTION_STRICT) ? TRUE : FALSE ))
+              {
+                      DBG(DBG_PARSING,
+                              DBG_log("Signing certificate is valid");
+                      );
+              }
+        else {
+          sk_X509_pop_free(peerlist, X509_free);
+          return STF_FAIL + INVALID_CERTIFICATE;
+        }
+      }
+      sk_X509_pop_free(peerlist, X509_free);
+      }
+      break;
+    default:
+      return STF_INTERNAL_ERROR;
+      break;
 	}
-    }
-
-    /* encrypt message, sans fixed part of header */
-
-    if (!encrypt_message(&md->rbody, st))
-	return STF_INTERNAL_ERROR;	/* ??? we may be partly committed */
 
-    /* Last block of Phase 1 (R3), kept for Phase 2 IV generation */
-    DBG_cond_dump(DBG_CRYPT, "last encrypted block of Phase 1:"
-	, st->st_new_iv, st->st_new_iv_len);
+    /**************** done input ****************/
 
     /* Advance state */
-    st->st_state = STATE_MAIN_R3;
-    ISAKMP_SA_established(st->st_connection, st->st_serialno);
+    st->st_state = STATE_MAIN_I4;
+    ISAKMP_SA_established(c, st->st_serialno);
 
-    /* ??? If st->st_connectionc->gw_info != NULL,
-     * we should keep the public key -- it tested out.
-     */
+    update_iv(st);    /* finalize our Phase 1 IV */
 
-    return STF_REPLY;
+    DBG(DBG_PARSING,
+    DBG_log("finished main_inR3_ds");
+    );
+
+    return STF_UNPEND_QUICK;
 }
+#endif
 
-/* STATE_MAIN_I3:
- * Handle HDR*;IDir;HASH/SIG_R from responder.
+#ifdef OPENSSL
+/* Handle HDR*;HASH_R from responder.
  */
 stf_status
-main_inR3(struct msg_digest *md)
+main_inR3_pk(struct msg_digest *md)
 {
     struct state *const st = md->st;
     struct connection *c = st->st_connection;
 
     /* input code similar to main_inI3_outR3 -- should be factored */
 
-    /* IDir in */
-    if (!decode_peer_id(md, TRUE))
-	return STF_FAIL + INVALID_ID_INFORMATION;
+    DBG(DBG_PARSING,
+    DBG_log("in main_inR3_pk");
+    );
 
-    /* HASH_R or SIG_R in */
+    /* HASH_R in */
+    // CHECK_HASH(main_mode_hash(st, hash_val, &hash_len, FALSE, FALSE)
+      // , "HASH_R", "Main R3");
     RETURN_STF_FAILURE(check_main_authenticator(md, FALSE));
 
     /**************** done input ****************/
